Unit SF76R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF76R5_p, UTSF14_p;

procedure SF76R1(Z :Real; var AI :Real; var BI :Real; var AID :Real;
                var BID :Real; L1 :Integer; var IERR :Integer);

implementation

procedure SF76R1(Z :Real; var AI :Real; var BI :Real; var AID :Real;
                var BID :Real; L1 :Integer; var IERR :Integer);
var
ANG,CN,FA,FB,FC,FD,SN,SX,X,Y,Z4,Z4I,ZETA,ZETAI :Real;
A :Array [0..4] of Real;
B :Array [0..4] of Real;
C :Array [0..4] of Real;
D :Array [0..4] of Real;
const
SYS009 :Real = 0.78539816339744830961566084581987;
ANGLM :Real = 250.0;
ANGUP :Real = 2.097151999875E6;
SYS038 :Real = 0.66666666666666666666666666666667;
label
_10,_20,_30,_40,_50,_60,_70;
begin
{   DATA  FORTRAN  }
A[0] := 1.1282427601;
A[1] := -0.6803534E-04;
A[2] := 0.16687E-06;
A[3] := -0.128E-08;
A[4] := 0.2E-10;
B[0] := 0.7822108673E-01;
B[1] := -0.6895649E-04;
B[2] := 0.32857E-06;
B[3] := -0.370E-08;
B[4] := 0.7E-10;
C[0] := 1.1285404716;
C[1] := 0.8046925E-04;
C[2] := -0.18161E-06;
C[3] := 0.135E-08;
C[4] := -0.2E-10;
D[0] := -0.10954855184;
D[1] := 0.7713350E-04;
D[2] := -0.35168E-06;
D[3] := 0.388E-08;
D[4] := -0.7E-10;
IERR  := 0;
X  := -Z;
SX  := Sqrt(X);
Y  := X*SX;
ZETA  := SYS038*Y;
Z4  := Sqrt(SX);
ANG  := ZETA + SYS009;
if ( ANGLM - ANG ) < 0
 then goto _10
 else if ( ANGLM - ANG ) > 0
       then goto _40
       else goto _40;
_10:
if ( ANGUP - ANG ) < 0
 then goto _20
 else if ( ANGUP - ANG ) > 0
       then goto _30
       else goto _20;
_20:
IERR  := 1;
AI  := 0.0;
BI  := 0.0;
AID  := 0.0;
BID  := 0.0;
goto _60;
_30:
IERR  := 2;
_40:
SN  := Sin(ANG);
CN  := Cos(ANG);
ZETAI  := 1.0/ZETA;
X  := 7.0/X;
X  := X*X*X;
if ( L1  <  0 )
 then goto _50;
SF76R5(X,5,A,FA);
SF76R5(X,5,B,FB);
Z4I  := 1.0/Z4;
FB  := FB*ZETAI;
AI  := Z4I*(SN*FA - CN*FB);
BI  := Z4I*(CN*FA + SN*FB);
if ( L1  >  0 )
 then goto _70;
_50:
SF76R5(X,5,C,FC);
SF76R5(X,5,D,FD);
FD  := FD*ZETAI;
AID  := -Z4*(CN*FC + SN*FD);
BID  := Z4*(SN*FC - CN*FD);
_60:
if ( IERR  <>  0 )
 then UTSF14(IERR,76);
_70:
end;

end.
