Unit SF76R4_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF76R5_p, UTSF14_p;

procedure SF76R4(Z :Real; var AI :Real; var BI :Real; var AID :Real;
                var BID :Real; L1 :Integer; L2 :Integer;
                var IERR :Integer);

implementation

procedure SF76R4(Z :Real; var AI :Real; var BI :Real; var AID :Real;
                var BID :Real; L1 :Integer; L2 :Integer;
                var IERR :Integer);
var
EX,EY,SZ,X,Y,Z4,Z4I,ZETA :Real;
A :Array [0..6] of Real;
B :Array [0..6] of Real;
C :Array [0..6] of Real;
D :Array [0..6] of Real;
const
ZUP :Real = 4.39804609E12;
SYS076 :Real = 8.872283E+01;
SYS059 :Real = 3.4E38;
SYS038 :Real = 0.66666666666666666666666666666667;
C18T5 :Real = 18.520259177;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
{   DATA  FORTRAN  }
A[0] := 0.56265126169;
A[1] := -0.76136219E-03;
A[2] := 0.765252E-05;
A[3] := -0.14228E-06;
A[4] := 0.380E-08;
A[5] := -0.13E-09;
A[6] := 0.1E-10;
B[0] := 1.1316635302;
B[1] := 0.166141673E-02;
B[2] := 0.1968882E-04;
B[3] := 0.47047E-06;
B[4] := 0.1769E-07;
B[5] := 0.94E-09;
B[6] := 0.6E-10;
C[0] := 0.56635357764;
C[1] := 0.107273242E-02;
C[2] := -0.910034E-05;
C[3] := 0.15998E-06;
C[4] := -0.415E-08;
C[5] := 0.14E-09;
C[6] := -01.0E-10;
D[0] := 1.1238058432;
D[1] := -0.230925296E-02;
D[2] := -0.2309457E-04;
D[3] := -0.52171E-06;
D[4] := -0.1907E-07;
D[5] := -0.100E-08;
D[6] := -0.7E-10;
IERR  := 0;
if ( ZUP - Z ) < 0
 then goto _10
 else if ( ZUP - Z ) > 0
       then goto _20
       else goto _20;
_10:
IERR  := 3;
AI  := 0.0;
BI  := 0.0;
AID  := 0.0;
BID  := 0.0;
goto _90;
_20:
SZ  := Sqrt(Z);
Y  := Z*SZ;
Z4  := Sqrt(SZ);
if ( L2 ) < 0
 then goto _30
 else if ( L2 ) > 0
       then goto _30
       else goto _40;
_30:
EX  := 1.0;
EY  := 1.0;
goto _70;
_40:
ZETA  := SYS038*Y;
if ( SYS076 - ZETA ) < 0
 then goto _50
 else if ( SYS076 - ZETA ) > 0
       then goto _60
       else goto _60;
_50:
IERR  := 4;
AI  := 0.0;
AID  := 0.0;
BI  := SYS059;
BID  := BI;
goto _90;
_60:
EX  := Exp(ZETA);
EY  := 1.0/EX;
_70:
X  := C18T5/Y;
if ( L1  <  0 ) 
 then goto _80;
SF76R5(X,7,A,AI);
SF76R5(X,7,B,BI);
Z4I  := 1.0/Z4;
AI  := Z4I*AI*EY;
BI  := Z4I*BI*EX;
if ( L1  >  0 ) 
 then goto _100;
_80:
SF76R5(X,7,C,AID);
SF76R5(X,7,D,BID);
AID  := -Z4*AID*EY;
BID  := Z4*BID*EX;
_90:
if ( IERR  <>  0 ) 
 then UTSF14(IERR,76);
_100:
end;

end.
